diff -Narup Mtd-orig/fs/jffs2/compr.h mtd/fs/jffs2/compr.h
--- Mtd-orig/fs/jffs2/compr.h	2005-11-08 02:02:14.000000000 +0100
+++ mtd/fs/jffs2/compr.h	2005-11-28 09:02:04.000000000 +0100
@@ -1,107 +1,66 @@
-/*
- * JFFS2 -- Journalling Flash File System, Version 2.
- *
- * Copyright (C) 2004 Ferenc Havasi <havasi@inf.u-szeged.hu>,
- *                    University of Szeged, Hungary
- *
- * For licensing information, see the file 'LICENCE' in the
- * jffs2 directory.
- *
- * $Id: compr.h,v 1.9 2005/11/07 11:14:38 gleixner Exp $
- *
- */
+#ifndef __COMPR_H
+#define __COMPR_H
 
-#ifndef __JFFS2_COMPR_H__
-#define __JFFS2_COMPR_H__
-
-#include <linux/kernel.h>
-#include <linux/vmalloc.h>
-#include <linux/list.h>
-#include <linux/types.h>
 #include <linux/string.h>
 #include <linux/slab.h>
-#include <linux/errno.h>
-#include <linux/fs.h>
-#include <linux/jffs2.h>
-#include <linux/jffs2_fs_i.h>
-#include <linux/jffs2_fs_sb.h>
-#include "nodelist.h"
-
-#define JFFS2_RUBINMIPS_PRIORITY 10
-#define JFFS2_DYNRUBIN_PRIORITY  20
-#define JFFS2_LZARI_PRIORITY     30
-#define JFFS2_LZO_PRIORITY       40
-#define JFFS2_RTIME_PRIORITY     50
-#define JFFS2_ZLIB_PRIORITY      60
-
-#define JFFS2_RUBINMIPS_DISABLED /* RUBINs will be used only */
-#define JFFS2_DYNRUBIN_DISABLED  /*        for decompression */
-
-#define JFFS2_COMPR_MODE_NONE       0
-#define JFFS2_COMPR_MODE_PRIORITY   1
-#define JFFS2_COMPR_MODE_SIZE       2
-
-struct jffs2_compressor {
-        struct list_head list;
-        int priority;              /* used by prirority comr. mode */
-        char *name;
-        char compr;                /* JFFS2_COMPR_XXX */
-        int (*compress)(unsigned char *data_in, unsigned char *cpage_out,
-                        uint32_t *srclen, uint32_t *destlen, void *model);
-        int (*decompress)(unsigned char *cdata_in, unsigned char *data_out,
-                        uint32_t cdatalen, uint32_t datalen, void *model);
-        int usecount;
-        int disabled;              /* if seted the compressor won't compress */
-        unsigned char *compr_buf;  /* used by size compr. mode */
-        uint32_t compr_buf_size;   /* used by size compr. mode */
-        uint32_t stat_compr_orig_size;
-        uint32_t stat_compr_new_size;
-        uint32_t stat_compr_blocks;
-        uint32_t stat_decompr_blocks;
+#include <linux/vmalloc.h>
+#include <linux/types.h>
+#include <linux/crypto.h>
+#include <linux/rwsem.h>
+
+#ifdef CONFIG_JFFS2_COMPR_COMPAT
+#include "compr_compat.h"
+#else
+#define jffs2_init_compr_compat() 0
+#define jffs2_exit_compr_compat()
+#define jffs2_create_compr_compat_context(a) 0
+#define jffs2_destroy_compr_compat_context(a)
+#endif
+
+typedef enum {COMPRESSMODE_NORMAL = 0, COMPRESSMODE_FIRSTCOMPRESS,
+			  COMPRESSMODE_BESTCOMPRESS} compressmode_t;
+
+#define JFFS2_STAT_BUF_SIZE 16000
+
+struct cryptolist_entry {
+	struct crypto_tfm *sess;
+	struct cryptolist_entry *next;
+	uint64_t tot_to_compress;
+	uint64_t tot_compressed;
+	uint64_t compr_blocks;
+	uint64_t tot_to_decompress;
+	uint64_t tot_decompressed;
+	uint64_t decompr_blocks;
 };
 
-int jffs2_register_compressor(struct jffs2_compressor *comp);
-int jffs2_unregister_compressor(struct jffs2_compressor *comp);
+struct compresstree_node {
+	struct compresstree_node *dad;
+	struct compresstree_node *fson;
+	struct compresstree_node *sib;
+	char *name;
+	compressmode_t node_type;
+};
 
-int jffs2_compressors_init(void);
-int jffs2_compressors_exit(void);
+struct compresstree_tail {
+	struct compresstree_node *owner;
+	char *tail;
+	struct compresstree_tail *next;
+};
 
-uint16_t jffs2_compress(struct jffs2_sb_info *c, struct jffs2_inode_info *f,
-                             unsigned char *data_in, unsigned char **cpage_out,
-                             uint32_t *datalen, uint32_t *cdatalen);
-
-int jffs2_decompress(struct jffs2_sb_info *c, struct jffs2_inode_info *f,
-                     uint16_t comprtype, unsigned char *cdata_in,
-                     unsigned char *data_out, uint32_t cdatalen, uint32_t datalen);
-
-void jffs2_free_comprbuf(unsigned char *comprbuf, unsigned char *orig);
-
-#ifdef CONFIG_JFFS2_PROC
-int jffs2_enable_compressor_name(const char *name);
-int jffs2_disable_compressor_name(const char *name);
-int jffs2_set_compression_mode_name(const char *mode_name);
-char *jffs2_get_compression_mode_name(void);
-int jffs2_set_compressor_priority(const char *mode_name, int priority);
-char *jffs2_list_compressors(void);
-char *jffs2_stats(void);
-#endif
+struct compress_ctx {
+	struct compresstree_node *compresstree_root;
+	struct cryptolist_entry *cryptolist_head;
+	struct cryptolist_entry *cryptolist_tail;
+	struct rw_semaphore crypto_lock;
+	struct rw_semaphore tree_lock;
+};
 
-/* Compressor modules */
-/* These functions will be called by jffs2_compressors_init/exit */
+struct compress_ctx *jffs2_create_compr_context(char *cnt);
+int jffs2_compress(struct compress_ctx **ctx, u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen);
+int jffs2_decompress(struct compress_ctx **ctx, u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen, int compressors);
+char *jffs2_compr_stats(struct compress_ctx **ctx);
+int jffs2_destroy_compr_context(struct compress_ctx **ctx);
+int jffs2_init_compr_engine(void);
+void jffs2_exit_compr_engine(void);
 
-#ifdef CONFIG_JFFS2_RUBIN
-int jffs2_rubinmips_init(void);
-void jffs2_rubinmips_exit(void);
-int jffs2_dynrubin_init(void);
-void jffs2_dynrubin_exit(void);
-#endif
-#ifdef CONFIG_JFFS2_RTIME
-int jffs2_rtime_init(void);
-void jffs2_rtime_exit(void);
 #endif
-#ifdef CONFIG_JFFS2_ZLIB
-int jffs2_zlib_init(void);
-void jffs2_zlib_exit(void);
-#endif
-
-#endif /* __JFFS2_COMPR_H__ */
diff -Narup Mtd-orig/fs/jffs2/compr_compat.c mtd/fs/jffs2/compr_compat.c
--- Mtd-orig/fs/jffs2/compr_compat.c	1970-01-01 01:00:00.000000000 +0100
+++ mtd/fs/jffs2/compr_compat.c	2005-11-28 10:19:04.000000000 +0100
@@ -0,0 +1,363 @@
+#include <linux/kernel.h>
+#include <linux/types.h>
+#include <linux/errno.h>
+#include <linux/string.h> 
+#include <linux/jffs2.h> 
+#include <linux/string.h>
+#include <linux/vmalloc.h>
+#include <linux/gfp.h>
+#include <linux/init.h>
+#include <linux/sched.h>
+#include <linux/rwsem.h>
+#include <linux/zlib.h>
+#include <linux/zutil.h>
+#include "compr_rubin.h"
+#include "histo_mips.h"
+
+#include "compr_compat.h"
+
+/*
+ * JFFS2 -- Journalling Flash File System, Version 2.
+ *
+ * Copyright (C) 2001-2003 Red Hat, Inc.
+ *
+ * Created by Arjan van de Ven <arjanv@redhat.com>
+ *
+ * For licensing information, see the file 'LICENCE' in this directory.
+ *
+ * $Id: compr_rtime.c,v 1.15 2005/03/17 20:23:06 gleixner Exp $
+ *
+ *
+ * Very simple lz77-ish encoder.
+ *
+ * Theory of operation: Both encoder and decoder have a list of "last
+ * occurrences" for every possible source-value; after sending the
+ * first source-byte, the second byte indicated the "run" length of
+ * matches
+ *
+ * The algorithm is intended to only send "whole bytes", no bit-messing.
+ *
+ */
+
+static int jffs2_rtime_decompress(unsigned char *data_in, unsigned char *cpage_out,
+									uint32_t srclen, uint32_t destlen)
+{
+	short positions[256];
+	int outpos = 0;
+	int pos=0;
+
+	memset(positions,0,sizeof(positions)); 
+
+	while (outpos<destlen) {
+		unsigned char value;
+		int backoffs;
+		int repeat;
+
+		value = data_in[pos++];
+		cpage_out[outpos++] = value; /* first the verbatim copied byte */
+		repeat = data_in[pos++];
+		backoffs = positions[value];
+
+		positions[value]=outpos;
+		if (repeat) {
+			if (backoffs + repeat >= outpos) {
+				while(repeat) {
+					cpage_out[outpos++] = cpage_out[backoffs++];
+					repeat--;
+				}
+			} else {
+				memcpy(&cpage_out[outpos],&cpage_out[backoffs],repeat);
+				outpos+=repeat;
+			}
+		}
+	}
+	return 0;
+}
+
+/*
+ * JFFS2 -- Journalling Flash File System, Version 2.
+ *
+ * Copyright (C) 2001, 2002 Red Hat, Inc.
+ *
+ * Created by Arjan van de Ven <arjanv@redhat.com>
+ *
+ * For licensing information, see the file 'LICENCE' in this directory.
+ *
+ * $Id: compr_rubin.c,v 1.21 2005/05/20 15:39:54 gleixner Exp $
+ *
+ */
+
+static void init_rubin(struct rubin_state *rs, int div, int *bits)
+{
+	int c;
+
+	rs->q = 0;
+	rs->p = (long) (2 * UPPER_BIT_RUBIN);
+	rs->bit_number = (long) 0;
+	rs->bit_divider = div;
+	for (c=0; c<8; c++)
+		rs->bits[c] = bits[c];
+}
+
+static void init_decode(struct rubin_state *rs, int div, int *bits)
+{
+	init_rubin(rs, div, bits);
+
+	/* behalve lower */
+	rs->rec_q = 0;
+
+	for (rs->bit_number = 0; rs->bit_number++ < RUBIN_REG_SIZE; rs->rec_q = rs->rec_q * 2 + (long) (pullbit(&rs->pp)))
+		;
+}
+
+static void __do_decode(struct rubin_state *rs, unsigned long p, unsigned long q)
+{
+	register unsigned long lower_bits_rubin = LOWER_BITS_RUBIN;
+	unsigned long rec_q;
+	int c, bits = 0;
+
+	/*
+	 * First, work out how many bits we need from the input stream.
+	 * Note that we have already done the initial check on this
+	 * loop prior to calling this function.
+	 */
+	do {
+		bits++;
+		q &= lower_bits_rubin;
+		q <<= 1;
+		p <<= 1;
+	} while ((q >= UPPER_BIT_RUBIN) || ((p + q) <= UPPER_BIT_RUBIN));
+
+	rs->p = p;
+	rs->q = q;
+
+	rs->bit_number += bits;
+
+	/*
+	 * Now get the bits.  We really want this to be "get n bits".
+	 */
+	rec_q = rs->rec_q;
+	do {
+		c = pullbit(&rs->pp);
+		rec_q &= lower_bits_rubin;
+		rec_q <<= 1;
+		rec_q += c;
+	} while (--bits);
+	rs->rec_q = rec_q;
+}
+
+static int decode(struct rubin_state *rs, long A, long B)
+{
+	unsigned long p = rs->p, q = rs->q;
+	long i0, threshold;
+	int symbol;
+
+	if (q >= UPPER_BIT_RUBIN || ((p + q) <= UPPER_BIT_RUBIN))
+		__do_decode(rs, p, q);
+
+	i0 = A * rs->p / (A + B);
+	if (i0 <= 0) {
+		i0 = 1;
+	}
+	if (i0 >= rs->p) {
+		i0 = rs->p - 1;
+	}
+
+	threshold = rs->q + i0;
+	symbol = rs->rec_q >= threshold;
+	if (rs->rec_q >= threshold) {
+		rs->q += i0;
+		i0 = rs->p - i0;
+	}
+
+	rs->p = i0;
+
+	return symbol;
+}
+
+static int in_byte(struct rubin_state *rs)
+{
+	int i, result = 0, bit_divider = rs->bit_divider;
+
+	for (i = 0; i < 8; i++)
+		result |= decode(rs, bit_divider - rs->bits[i], rs->bits[i]) << i;
+
+	return result;
+}
+
+static void rubin_do_decompress(int bit_divider, int *bits, unsigned char *cdata_in,
+						unsigned char *page_out, uint32_t srclen, uint32_t destlen)
+{
+	int outpos = 0;
+	struct rubin_state rs;
+
+	init_pushpull(&rs.pp, cdata_in, srclen, 0, 0);
+	init_decode(&rs, bit_divider, bits);
+
+	while (outpos < destlen) {
+		page_out[outpos++] = in_byte(&rs);
+	}
+} 
+
+
+static int jffs2_rubinmips_decompress(unsigned char *data_in, unsigned char *cpage_out,
+										uint32_t sourcelen, uint32_t dstlen)
+{
+	rubin_do_decompress(BIT_DIVIDER_MIPS, bits_mips, data_in, cpage_out, sourcelen, dstlen);
+	return 0;
+}
+
+static int jffs2_dynrubin_decompress(unsigned char *data_in, unsigned char *cpage_out,
+										uint32_t sourcelen, uint32_t dstlen)
+{
+	int bits[8];
+	int c;
+
+	for (c=0; c<8; c++)
+		bits[c] = data_in[c];
+
+	rubin_do_decompress(256, bits, data_in+8, cpage_out, sourcelen-8, dstlen);
+	return 0;
+}
+
+/*
+ * JFFS2 -- Journalling Flash File System, Version 2.
+ *
+ * Copyright (C) 2001-2003 Red Hat, Inc.
+ *
+ * Created by David Woodhouse <dwmw2@infradead.org>
+ *
+ * For licensing information, see the file 'LICENCE' in this directory.
+ *
+ * $Id: compr_zlib.c,v 1.31 2005/05/20 19:30:06 gleixner Exp $
+ *
+ */
+
+	/* Plan: call deflate() with avail_in == *sourcelen, 
+		avail_out = *dstlen - 12 and flush == Z_FINISH. 
+		If it doesn't manage to finish,	call it again with
+		avail_in == 0 and avail_out set to the remaining 12
+		bytes for it to clean up. 
+	   Q: Is 12 bytes sufficient?
+	*/
+#define STREAM_END_SPACE 12
+
+static int jffs2_zlib_decompress(z_stream *inf_strm, unsigned char *data_in,
+				 unsigned char *cpage_out, uint32_t srclen, uint32_t destlen)
+{
+	int ret;
+	int wbits = MAX_WBITS;
+
+	inf_strm->next_in = data_in;
+	inf_strm->avail_in = srclen;
+	inf_strm->total_in = 0;
+
+	inf_strm->next_out = cpage_out;
+	inf_strm->avail_out = destlen;
+	inf_strm->total_out = 0;
+
+	/* If it's deflate, and it's got no preset dictionary, then
+	   we can tell zlib to skip the adler32 check. */
+	if (srclen > 2 && !(data_in[1] & PRESET_DICT) &&
+		((data_in[0] & 0x0f) == Z_DEFLATED) &&
+		!(((data_in[0]<<8) + data_in[1]) % 31)) {
+		wbits = -((data_in[0] >> 4) + 8);
+		inf_strm->next_in += 2;
+		inf_strm->avail_in -= 2;
+	}
+
+	if (Z_OK != zlib_inflateInit2(inf_strm, wbits)) {
+		printk(KERN_WARNING "inflateInit failed\n");
+		return 1;
+	}
+
+	while((ret = zlib_inflate(inf_strm, Z_FINISH)) == Z_OK)
+		;
+	if (ret != Z_STREAM_END) {
+		printk(KERN_NOTICE "inflate returned %d\n", ret);
+	}
+	zlib_inflateEnd(inf_strm);
+	return 0;
+}
+
+static struct rw_semaphore compress_compat_lock;
+static kmem_cache_t *compat_ctx_cache = NULL;
+
+int jffs2_init_compr_compat(void)
+{
+	int ret = 0;
+	init_rwsem(&compress_compat_lock);
+	compat_ctx_cache = kmem_cache_create("compress_compat_ctx",
+								sizeof(struct compress_compat_ctx), 0,
+								SLAB_HWCACHE_ALIGN, NULL, NULL);
+	if (unlikely(!compat_ctx_cache))
+		ret = -ENOMEM;
+	return ret;
+}
+
+void jffs2_exit_compr_compat(void)
+{
+	if (compat_ctx_cache)
+		kmem_cache_destroy(compat_ctx_cache);
+}
+
+int jffs2_create_compr_compat_context(struct compress_compat_ctx **ctx)
+{
+	int ret = 0;
+
+	down_write(&compress_compat_lock);
+	*ctx = kmem_cache_alloc(compat_ctx_cache, GFP_KERNEL);
+	if (unlikely(!(*ctx))) {
+		ret = -ENOMEM;
+		goto out;
+	}
+	(*ctx)->inf_strm.workspace = vmalloc(zlib_inflate_workspacesize());
+	if (unlikely(!(*ctx)->inf_strm.workspace)) {
+		kmem_cache_free(compat_ctx_cache, *ctx);
+		*ctx = NULL;
+		ret = -ENOMEM;
+	}
+	init_MUTEX(&(*ctx)->z_sem);
+out:
+	up_write(&compress_compat_lock);
+	return ret;
+}
+
+void jffs2_destroy_compr_compat_context(struct compress_compat_ctx **ctx)
+{
+	down_write(&compress_compat_lock);
+	if (!*ctx)
+		goto out;
+	vfree((*ctx)->inf_strm.workspace);
+	kmem_cache_free(compat_ctx_cache, *ctx);
+	*ctx = NULL;
+out:
+	up_write(&compress_compat_lock);
+}
+
+int jffs2_decompress_compat(struct compress_compat_ctx **ctx, u8 *src,
+				int32_t srclen, u8 *dst, int32_t dstlen, int compressor)
+{
+	int ret = 0;
+	down_read(&compress_compat_lock);
+	if (!*ctx)
+		goto out;
+	switch (compressor) {
+		case JFFS2_COMPR_RTIME:
+			ret = jffs2_rtime_decompress(src, dst, srclen, dstlen);
+			break;
+		case JFFS2_COMPR_RUBINMIPS:
+			ret = jffs2_rubinmips_decompress(src, dst, srclen, dstlen);
+			break;
+		case JFFS2_COMPR_DYNRUBIN:
+			ret = jffs2_dynrubin_decompress(src, dst, srclen, dstlen);
+			break;
+		case JFFS2_COMPR_ZLIB:
+			down(&(*ctx)->z_sem);
+			ret = jffs2_zlib_decompress(&(*ctx)->inf_strm, src, dst, srclen, dstlen);
+			up(&(*ctx)->z_sem);
+	}
+out:
+	up_read(&compress_compat_lock);
+	return ret;
+}
diff -Narup Mtd-orig/fs/jffs2/compr_compat.h mtd/fs/jffs2/compr_compat.h
--- Mtd-orig/fs/jffs2/compr_compat.h	1970-01-01 01:00:00.000000000 +0100
+++ mtd/fs/jffs2/compr_compat.h	2005-11-28 10:19:04.000000000 +0100
@@ -0,0 +1,21 @@
+#ifndef __COMPR_COMPAT_H
+#define __COMPR_COMPAT_H
+
+#include <linux/kernel.h>
+#include <linux/types.h>
+#include <linux/zlib.h>
+#include <linux/zutil.h>
+
+struct compress_compat_ctx {
+	z_stream inf_strm;
+	struct semaphore z_sem;
+};
+
+int jffs2_init_compr_compat(void);
+void jffs2_exit_compr_compat(void);
+int jffs2_create_compr_compat_context(struct compress_compat_ctx **ctx);
+void jffs2_destroy_compr_compat_context(struct compress_compat_ctx **ctx);
+int jffs2_decompress_compat(struct compress_compat_ctx **ctx, u8 *src,
+						int32_t srclen, u8 *dst, int32_t dstlen, int compressor);
+
+#endif
diff -Narup Mtd-orig/fs/jffs2/compr_rubin.h mtd/fs/jffs2/compr_rubin.h
--- Mtd-orig/fs/jffs2/compr_rubin.h	2005-11-08 02:02:14.000000000 +0100
+++ mtd/fs/jffs2/compr_rubin.h	2005-11-28 10:19:04.000000000 +0100
@@ -1,7 +1,7 @@
 /* Rubin encoder/decoder header       */
 /* work started at   : aug   3, 1994  */
 /* last modification : aug  15, 1994  */
-/* $Id: compr_rubin.h,v 1.7 2005/11/07 11:14:38 gleixner Exp $ */
+/* $Id: compr_rubin.h,v 1.6 2002/01/25 01:49:26 dwmw2 Exp $ */
 
 #include "pushpull.h"
 
diff -Narup Mtd-orig/fs/jffs2/gc.c mtd/fs/jffs2/gc.c
--- Mtd-orig/fs/jffs2/gc.c	2005-11-14 02:03:03.000000000 +0100
+++ mtd/fs/jffs2/gc.c	2005-11-28 10:19:04.000000000 +0100
@@ -1060,8 +1060,8 @@ static int jffs2_garbage_collect_dnode(s
 	struct jffs2_full_dnode *new_fn;
 	struct jffs2_raw_inode ri;
 	uint32_t alloclen, phys_ofs, offset, orig_end, orig_start;
-	int ret = 0;
-	unsigned char *comprbuf = NULL, *writebuf;
+	int ret = 0, cr;
+	unsigned char *comprbuf = NULL, *writebuf, *finalbuf;
 	unsigned long pg;
 	unsigned char *pg_ptr;
 
@@ -1214,7 +1214,6 @@ static int jffs2_garbage_collect_dnode(s
 	while(offset < orig_end) {
 		uint32_t datalen;
 		uint32_t cdatalen;
-		uint16_t comprtype = JFFS2_COMPR_NONE;
 
 		ret = jffs2_reserve_space_gc(c, sizeof(ri) + JFFS2_MIN_DATA_LEN, &phys_ofs,
 					&alloclen, JFFS2_SUMMARY_INODE_SIZE);
@@ -1224,12 +1223,24 @@ static int jffs2_garbage_collect_dnode(s
 			       sizeof(ri)+ JFFS2_MIN_DATA_LEN, ret);
 			break;
 		}
-		cdatalen = min_t(uint32_t, alloclen - sizeof(ri), end - offset);
 		datalen = end - offset;
+		cdatalen = min_t(uint32_t, alloclen - sizeof(ri), datalen);
 
 		writebuf = pg_ptr + (offset & (PAGE_CACHE_SIZE -1));
 
-		comprtype = jffs2_compress(c, f, writebuf, &comprbuf, &datalen, &cdatalen);
+		comprbuf = (unsigned char *) __get_free_page(GFP_KERNEL);
+
+		cr = jffs2_compress(&c->ctx, writebuf, datalen, comprbuf, &cdatalen);
+		if (likely(cr > 0)) {
+			ri.compr = JFFS2_COMPR_ENGINE;
+			ri.usercompr = cr;
+			finalbuf = comprbuf;
+		} else {
+			ri.compr = JFFS2_COMPR_NONE;
+			ri.usercompr = 0;
+			datalen = cdatalen;
+			finalbuf = writebuf;
+		}
 
 		ri.magic = cpu_to_je16(JFFS2_MAGIC_BITMASK);
 		ri.nodetype = cpu_to_je16(JFFS2_NODETYPE_INODE);
@@ -1248,14 +1259,12 @@ static int jffs2_garbage_collect_dnode(s
 		ri.offset = cpu_to_je32(offset);
 		ri.csize = cpu_to_je32(cdatalen);
 		ri.dsize = cpu_to_je32(datalen);
-		ri.compr = comprtype & 0xff;
-		ri.usercompr = (comprtype >> 8) & 0xff;
 		ri.node_crc = cpu_to_je32(crc32(0, &ri, sizeof(ri)-8));
-		ri.data_crc = cpu_to_je32(crc32(0, comprbuf, cdatalen));
+		ri.data_crc = cpu_to_je32(crc32(0, finalbuf, cdatalen));
 
-		new_fn = jffs2_write_dnode(c, f, &ri, comprbuf, cdatalen, phys_ofs, ALLOC_GC);
+		new_fn = jffs2_write_dnode(c, f, &ri, finalbuf, cdatalen, phys_ofs, ALLOC_GC);
 
-		jffs2_free_comprbuf(comprbuf, writebuf);
+		free_page((unsigned long) comprbuf);
 
 		if (IS_ERR(new_fn)) {
 			printk(KERN_WARNING "Error writing new dnode: %ld\n", PTR_ERR(new_fn));
diff -Narup Mtd-orig/fs/jffs2/read.c mtd/fs/jffs2/read.c
--- Mtd-orig/fs/jffs2/read.c	2005-11-14 02:03:03.000000000 +0100
+++ mtd/fs/jffs2/read.c	2005-11-28 10:19:04.000000000 +0100
@@ -20,13 +20,17 @@
 #include "nodelist.h"
 #include "compr.h"
 
+#ifdef CONFIG_JFFS2_COMPR_COMPAT
+#include "compr_compat.h"
+#endif
+
 int jffs2_read_dnode(struct jffs2_sb_info *c, struct jffs2_inode_info *f,
 		     struct jffs2_full_dnode *fd, unsigned char *buf,
 		     int ofs, int len)
 {
 	struct jffs2_raw_inode *ri;
 	size_t readlen;
-	uint32_t crc;
+	uint32_t crc, declen;
 	unsigned char *decomprbuf = NULL;
 	unsigned char *readbuf = NULL;
 	int ret = 0;
@@ -125,15 +129,29 @@ int jffs2_read_dnode(struct jffs2_sb_inf
 		goto out_decomprbuf;
 	}
 	D2(printk(KERN_DEBUG "Data CRC matches calculated CRC %08x\n", crc));
-	if (ri->compr != JFFS2_COMPR_NONE) {
+	if (ri->compr == JFFS2_COMPR_ENGINE) {
 		D2(printk(KERN_DEBUG "Decompress %d bytes from %p to %d bytes at %p\n",
 			  je32_to_cpu(ri->csize), readbuf, je32_to_cpu(ri->dsize), decomprbuf));
-		ret = jffs2_decompress(c, f, ri->compr | (ri->usercompr << 8), readbuf, decomprbuf, je32_to_cpu(ri->csize), je32_to_cpu(ri->dsize));
+		declen = je32_to_cpu(ri->dsize);
+		ret = jffs2_decompress(&c->ctx, readbuf, je32_to_cpu(ri->csize), decomprbuf, &declen, ri->usercompr);
+		if (ret) {
+			printk(KERN_WARNING "Error: decompress returned %d\n", ret);
+			goto out_decomprbuf;
+		}
+	}
+
+#ifdef CONFIG_JFFS2_COMPR_COMPAT
+	else if (ri->compr != JFFS2_COMPR_NONE) {
+		D2(printk(KERN_DEBUG "Compat decompress %d bytes from %p to %d bytes at %p\n",
+			  je32_to_cpu(ri->csize), readbuf, je32_to_cpu(ri->dsize), decomprbuf));
+		ret = jffs2_decompress_compat(&c->compat_ctx, readbuf, je32_to_cpu(ri->csize), decomprbuf,
+				declen, ri->compr);
 		if (ret) {
-			printk(KERN_WARNING "Error: jffs2_decompress returned %d\n", ret);
+			printk(KERN_WARNING "Error: decompress compat returned %d\n", ret);
 			goto out_decomprbuf;
 		}
 	}
+#endif
 
 	if (len < je32_to_cpu(ri->dsize)) {
 		memcpy(buf, decomprbuf+ofs, len);
diff -Narup Mtd-orig/fs/jffs2/super.c mtd/fs/jffs2/super.c
--- Mtd-orig/fs/jffs2/super.c	2005-11-12 02:02:11.000000000 +0100
+++ mtd/fs/jffs2/super.c	2005-11-28 10:19:04.000000000 +0100
@@ -14,6 +14,7 @@
 #include <linux/config.h>
 #include <linux/kernel.h>
 #include <linux/module.h>
+#include <linux/moduleparam.h>
 #include <linux/slab.h>
 #include <linux/init.h>
 #include <linux/list.h>
@@ -27,6 +28,8 @@
 #include "compr.h"
 #include "nodelist.h"
 
+static char *compr_control = CONFIG_JFFS2_COMPR_CONTROL;
+
 static void jffs2_put_super(struct super_block *);
 
 static kmem_cache_t *jffs2_inode_cachep;
@@ -125,6 +128,19 @@ static struct super_block *jffs2_get_sb_
 	memset(c, 0, sizeof(*c));
 	c->mtd = mtd;
 
+	c->ctx = jffs2_create_compr_context(compr_control);
+	if (!c->ctx) {
+		kfree(c);
+		return ERR_PTR(-EFAULT);
+	}
+
+	ret = jffs2_create_compr_compat_context(&c->compat_ctx);
+	if (ret) {
+		jffs2_destroy_compr_context(&c->ctx);
+		kfree(c);
+		return ERR_PTR(-EFAULT);
+	}
+
 	sb = sget(fs_type, jffs2_sb_compare, jffs2_sb_set, c);
 
 	if (IS_ERR(sb))
@@ -165,9 +181,10 @@ static struct super_block *jffs2_get_sb_
 	return sb;
 
  out_put:
+	jffs2_destroy_compr_compat_context(&c->compat_ctx);
+	jffs2_destroy_compr_context(&c->ctx);
 	kfree(c);
 	put_mtd_device(mtd);
-
 	return sb;
 }
 
@@ -302,6 +319,8 @@ static void jffs2_kill_sb(struct super_b
 	if (!(sb->s_flags & MS_RDONLY))
 		jffs2_stop_garbage_collect_thread(c);
 	generic_shutdown_super(sb);
+	jffs2_destroy_compr_compat_context(&c->compat_ctx);
+	jffs2_destroy_compr_context(&c->ctx);
 	put_mtd_device(c->mtd);
 	kfree(c);
 }
@@ -334,15 +353,20 @@ static int __init init_jffs2_fs(void)
 		printk(KERN_ERR "JFFS2 error: Failed to initialise inode cache\n");
 		return -ENOMEM;
 	}
-	ret = jffs2_compressors_init();
+	ret = jffs2_init_compr_engine();
 	if (ret) {
-		printk(KERN_ERR "JFFS2 error: Failed to initialise compressors\n");
+		printk(KERN_ERR "JFFS2 error: Failed to initialise compressor engine\n");
 		goto out;
 	}
+	ret = jffs2_init_compr_compat();
+	if (ret) {
+		printk(KERN_ERR "JFFS2 error: Failed to initialise decompressor compatibility engine\n");
+		goto out_compressors;
+	}
 	ret = jffs2_create_slab_caches();
 	if (ret) {
 		printk(KERN_ERR "JFFS2 error: Failed to initialise slab caches\n");
-		goto out_compressors;
+		goto out_compr_compat;
 	}
 	ret = register_filesystem(&jffs2_fs_type);
 	if (ret) {
@@ -353,8 +377,10 @@ static int __init init_jffs2_fs(void)
 
  out_slab:
 	jffs2_destroy_slab_caches();
+ out_compr_compat:
+	jffs2_exit_compr_compat();
  out_compressors:
-	jffs2_compressors_exit();
+	jffs2_exit_compr_engine();
  out:
 	kmem_cache_destroy(jffs2_inode_cachep);
 	return ret;
@@ -364,13 +390,16 @@ static void __exit exit_jffs2_fs(void)
 {
 	unregister_filesystem(&jffs2_fs_type);
 	jffs2_destroy_slab_caches();
-	jffs2_compressors_exit();
+	jffs2_exit_compr_compat();
+	jffs2_exit_compr_engine();
 	kmem_cache_destroy(jffs2_inode_cachep);
 }
 
 module_init(init_jffs2_fs);
 module_exit(exit_jffs2_fs);
 
+module_param(compr_control, charp, S_IRUGO);
+
 MODULE_DESCRIPTION("The Journalling Flash File System, v2");
 MODULE_AUTHOR("Red Hat, Inc.");
 MODULE_LICENSE("GPL"); // Actually dual-licensed, but it doesn't matter for
diff -Narup Mtd-orig/fs/jffs2/write.c mtd/fs/jffs2/write.c
--- Mtd-orig/fs/jffs2/write.c	2005-11-12 02:02:11.000000000 +0100
+++ mtd/fs/jffs2/write.c	2005-11-28 10:19:04.000000000 +0100
@@ -349,7 +349,7 @@ int jffs2_write_inode_range(struct jffs2
 			    struct jffs2_raw_inode *ri, unsigned char *buf,
 			    uint32_t offset, uint32_t writelen, uint32_t *retlen)
 {
-	int ret = 0;
+	int ret = 0, cr;
 	uint32_t writtenlen = 0;
 
        	D1(printk(KERN_DEBUG "jffs2_write_inode_range(): Ino #%u, ofs 0x%x, len 0x%x\n",
@@ -357,8 +357,7 @@ int jffs2_write_inode_range(struct jffs2
 
 	while(writelen) {
 		struct jffs2_full_dnode *fn;
-		unsigned char *comprbuf = NULL;
-		uint16_t comprtype = JFFS2_COMPR_NONE;
+		unsigned char *comprbuf = NULL, *finalbuf;
 		uint32_t phys_ofs, alloclen;
 		uint32_t datalen, cdatalen;
 		int retried = 0;
@@ -376,7 +375,19 @@ int jffs2_write_inode_range(struct jffs2
 		datalen = min_t(uint32_t, writelen, PAGE_CACHE_SIZE - (offset & (PAGE_CACHE_SIZE-1)));
 		cdatalen = min_t(uint32_t, alloclen - sizeof(*ri), datalen);
 
-		comprtype = jffs2_compress(c, f, buf, &comprbuf, &datalen, &cdatalen);
+		comprbuf = (unsigned char *) __get_free_page(GFP_KERNEL);
+
+		cr = jffs2_compress(&c->ctx, buf, datalen, comprbuf, &cdatalen);
+		if (likely(cr > 0)) {
+			ri->compr = JFFS2_COMPR_ENGINE;
+			ri->usercompr = cr;
+			finalbuf = comprbuf;
+		} else {
+			ri->compr = JFFS2_COMPR_NONE;
+			ri->usercompr = 0;
+			datalen = cdatalen;
+			finalbuf = buf;
+		}
 
 		ri->magic = cpu_to_je16(JFFS2_MAGIC_BITMASK);
 		ri->nodetype = cpu_to_je16(JFFS2_NODETYPE_INODE);
@@ -389,14 +400,12 @@ int jffs2_write_inode_range(struct jffs2
 		ri->offset = cpu_to_je32(offset);
 		ri->csize = cpu_to_je32(cdatalen);
 		ri->dsize = cpu_to_je32(datalen);
-		ri->compr = comprtype & 0xff;
-		ri->usercompr = (comprtype >> 8 ) & 0xff;
 		ri->node_crc = cpu_to_je32(crc32(0, ri, sizeof(*ri)-8));
-		ri->data_crc = cpu_to_je32(crc32(0, comprbuf, cdatalen));
+		ri->data_crc = cpu_to_je32(crc32(0, finalbuf, cdatalen));
 
-		fn = jffs2_write_dnode(c, f, ri, comprbuf, cdatalen, phys_ofs, ALLOC_NORETRY);
+		fn = jffs2_write_dnode(c, f, ri, finalbuf, cdatalen, phys_ofs, ALLOC_NORETRY);
 
-		jffs2_free_comprbuf(comprbuf, buf);
+		free_page((unsigned long) comprbuf);
 
 		if (IS_ERR(fn)) {
 			ret = PTR_ERR(fn);
diff -Narup Mtd-orig/include/linux/jffs2.h mtd/include/linux/jffs2.h
--- Mtd-orig/include/linux/jffs2.h	2005-11-08 02:02:17.000000000 +0100
+++ mtd/include/linux/jffs2.h	2005-11-28 10:19:04.000000000 +0100
@@ -46,11 +46,14 @@
 
 #define JFFS2_COMPR_NONE	0x00
 #define JFFS2_COMPR_ZERO	0x01
+#define JFFS2_COMPR_COPY	0x04
+#define JFFS2_COMPR_ENGINE	0x10
+
 #define JFFS2_COMPR_RTIME	0x02
 #define JFFS2_COMPR_RUBINMIPS	0x03
-#define JFFS2_COMPR_COPY	0x04
 #define JFFS2_COMPR_DYNRUBIN	0x05
 #define JFFS2_COMPR_ZLIB	0x06
+
 /* Compatibility flags. */
 #define JFFS2_COMPAT_MASK 0xc000      /* What do to if an unknown nodetype is found */
 #define JFFS2_NODE_ACCURATE 0x2000
diff -Narup Mtd-orig/include/linux/jffs2_fs_sb.h mtd/include/linux/jffs2_fs_sb.h
--- Mtd-orig/include/linux/jffs2_fs_sb.h	2005-11-12 02:02:14.000000000 +0100
+++ mtd/include/linux/jffs2_fs_sb.h	2005-11-28 10:19:04.000000000 +0100
@@ -18,6 +18,10 @@
 #define JFFS2_SB_FLAG_BUILDING 4 /* File system building is in progress */
 
 struct jffs2_inodirty;
+struct compress_ctx;
+#ifdef CONFIG_JFFS2_COMPR_COMPAT
+struct compress_compat_ctx;
+#endif
 
 /* A struct for the overall file system control.  Pointers to
    jffs2_sb_info structs are named `c' in the source code.
@@ -117,6 +121,11 @@ struct jffs2_sb_info {
 
 	uint32_t ebh_size;	/* This is the space size occupied by eraseblock_header on flash */
 
+	struct compress_ctx *ctx;
+#ifdef CONFIG_JFFS2_COMPR_COMPAT
+	struct compress_compat_ctx *compat_ctx;
+#endif
+
 	/* OS-private pointer for getting back to master superblock info */
 	void *os_priv;
 };
diff -Narup Mtd-orig/patches/patchin.sh mtd/patches/patchin.sh
--- Mtd-orig/patches/patchin.sh	2005-09-15 14:18:41.000000000 +0200
+++ mtd/patches/patchin.sh	2005-11-28 10:19:04.000000000 +0100
@@ -411,7 +411,7 @@ MTD_FILES_EX26="mtd_blkdevs-24.c blkmtd-
 # JFFS2 files and directories
 JFFS2_DIRS="fs/jffs2"
 JFFS2_FILES="*.[ch] Makefile Rules.make"
-JFFS2_FILES_EX26="compr_lzari.c compr_lzo.c crc32.[hc] rbtree.c super-v24.c symlink-v24.c"
+JFFS2_FILES_EX26="crc32.[hc] rbtree.c super-v24.c symlink-v24.c"
 # kernel version < 2.4.20 needs zlib headers
 JFFS2_INC_BEL2420="jffs*.h workqueue.h z*.h rb*.h suspend.h"
 # kernel version < 2.5.x
diff -Narup Mtd-orig/util/Makefile mtd/util/Makefile
--- Mtd-orig/util/Makefile	2005-11-08 02:02:19.000000000 +0100
+++ mtd/util/Makefile	2005-11-28 10:19:04.000000000 +0100
@@ -11,7 +11,7 @@ CC := $(CROSS)gcc
 CFLAGS := -I../include -O2 -Wall
 
 TARGETS = ftl_format flash_erase flash_eraseall nanddump doc_loadbios \
-	mkfs.jffs ftl_check mkfs.jffs2 flash_lock flash_unlock flash_info \
+	mkfs.jffs ftl_check mkfs-old.jffs2 flash_lock flash_unlock flash_info \
 	flash_otp_info flash_otp_dump mtd_debug flashcp nandwrite \
 	jffs2dump \
 	nftldump nftl_format docfdisk \
@@ -34,12 +34,15 @@ IGNORE=${wildcard .*.c.dep}
 -include ${IGNORE}
 
 clean:
-	rm -f *.o $(TARGETS) .*.c.dep $(SYMLINKS)
+	rm -f *.o $(TARGETS) mkfs.jffs2 .*.c.dep $(SYMLINKS)
 
 $(SYMLINKS):
 	ln -sf ../fs/jffs2/$@ $@
 
-mkfs.jffs2: crc32.o compr_rtime.o mkfs.jffs2.o compr_zlib.o compr.o
+mkfs.jffs2: crc32.o mkfs.jffs2.o compr.o
+	$(CC) $(LDFLAGS) -o $@ $^
+
+mkfs-old.jffs2: crc32.o compr_rtime-old.o mkfs-old.jffs2.o compr_zlib-old.o compr-old.o
 	$(CC) $(LDFLAGS) -o $@ $^ -lz
 
 flash_eraseall: crc32.o flash_eraseall.o
